zl程序教程

您现在的位置是:首页 >  其它

当前栏目

Codeforces Round #416 (Div. 2) 本来以为这个时间是晚上的,下午就没做

时间 Codeforces 这个 div round 以为 下午 晚上
2023-09-14 09:11:42 时间
A. Vladik and Courtesy
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

At regular competition Vladik and Valera won a and b candies respectively. Vladik offered 1 his candy to Valera. After that Valera gave Vladik 2 his candies, so that no one thought that he was less generous. Vladik for same reason gave 3 candies to Valera in next turn.

More formally, the guys take turns giving each other one candy more than they received in the previous turn.

This continued until the moment when one of them couldn’t give the right amount of candy. Candies, which guys got from each other, they don’t consider as their own. You need to know, who is the first who can’t give the right amount of candy.

Input

Single line of input data contains two space-separated integers ab (1 ≤ a, b ≤ 109) — number of Vladik and Valera candies respectively.

Output

Pring a single line "Vladik’’ in case, if Vladik first who can’t give right amount of candy, or "Valera’’ otherwise.

Examples
input
1 1
output
Valera
input
7 6
output
Vladik
Note

Illustration for first test case:

Illustration for second test case:

 

 两个人的糖果数分别-1-3-5-7,-2-4-6-8,看谁更持久,等差数列求和啊,因为数据量不大,所以直接模拟也是可以过的

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
int main(){
    ll a, b, n, m;
    cin >> a >> b;
    n = sqrt(a);
    m = (-1.0+sqrt(1+4*b))/2.0;
    if (n > m){
        cout << "Valera";
    }
    else cout << "Vladik";
    return 0;
}
B. Vladik and Complicated Book
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Vladik had started reading a complicated book about algorithms containing n pages. To improve understanding of what is written, his friends advised him to read pages in some order given by permutation P = [p1, p2, ..., pn], where pi denotes the number of page that should be read i-th in turn.

Sometimes Vladik’s mom sorted some subsegment of permutation P from position l to position r inclusive, because she loves the order. For every of such sorting Vladik knows number x — what index of page in permutation he should read. He is wondered if the page, which he will read after sorting, has changed. In other words, has px changed? After every sorting Vladik return permutation to initial state, so you can assume that each sorting is independent from each other.

Input

First line contains two space-separated integers nm (1 ≤ n, m ≤ 104) — length of permutation and number of times Vladik's mom sorted some subsegment of the book.

Second line contains n space-separated integers p1, p2, ..., pn (1 ≤ pi ≤ n) — permutation P. Note that elements in permutation are distinct.

Each of the next m lines contains three space-separated integers lirixi (1 ≤ li ≤ xi ≤ ri ≤ n) — left and right borders of sorted subsegment in i-th sorting and position that is interesting to Vladik.

Output

For each mom’s sorting on it’s own line print "Yes", if page which is interesting to Vladik hasn't changed, or "No" otherwise.

Examples
input
5 5
5 4 3 2 1
1 5 3
1 3 1
2 4 3
4 4 4
2 5 3
output
Yes
No
Yes
Yes
No
input
6 5
1 4 3 2 5 6
2 4 3
1 6 2
4 5 4
1 3 3
2 6 3
output
Yes
No
Yes
No
Yes
Note

Explanation of first test case:

  1. [1, 2, 3, 4, 5] — permutation after sorting, 3-rd element hasn’t changed, so answer is "Yes".
  2. [3, 4, 5, 2, 1] — permutation after sorting, 1-st element has changed, so answer is "No".
  3. [5, 2, 3, 4, 1] — permutation after sorting, 3-rd element hasn’t changed, so answer is "Yes".
  4. [5, 4, 3, 2, 1] — permutation after sorting, 4-th element hasn’t changed, so answer is "Yes".
  5. [5, 1, 2, 3, 4] — permutation after sorting, 3-rd element has changed, so answer is "No".

 

题意:给出一串数,然后有m个问题,每个问题给出一个区间 【l,r】对区间内的数进行排序,问第x个数的位置是否改变。

 群里有大佬用了线数段的做法,可是div2怎么会那么难啊,统计下<=a[x]的不久好了

#include <bits/stdc++.h>
using namespace std;
const int maxn=10000+5;
int n,m;
int p[maxn];
int main()
{
    scanf("%d %d",&n,&m);
    for(int i=1;i<=n;i++)
        scanf("%d",&p[i]);
        int l,r,x;
    for(int i=0;i<m;i++){
        scanf("%d %d %d",&l,&r,&x);
    int hh=p[x];
    int cnt=1;
    for(int j=l;j<=r;j++){
        if(j==x)
            continue;
        if(p[j]<hh)
            cnt++;
    }
    if(cnt+l-1==x)
        printf("Yes\n");
    else printf("No\n");
    }
    return 0;
}

 

C. Vladik and Memorable Trip
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Vladik often travels by trains. He remembered some of his trips especially well and I would like to tell you about one of these trips:

Vladik is at initial train station, and now n people (including Vladik) want to get on the train. They are already lined up in some order, and for each of them the city code ai is known (the code of the city in which they are going to).

Train chief selects some number of disjoint segments of the original sequence of people (covering entire sequence by segments is not necessary). People who are in the same segment will be in the same train carriage. The segments are selected in such way that if at least one person travels to the city x, then all people who are going to city x should be in the same railway carriage. This means that they can’t belong to different segments. Note, that all people who travel to the city x, either go to it and in the same railway carriage, or do not go anywhere at all.

Comfort of a train trip with people on segment from position l to position r is equal to XOR of all distinct codes of cities for people on the segment from position l to position rXOR operation also known as exclusive OR.

Total comfort of a train trip is equal to sum of comfort for each segment.

Help Vladik to know maximal possible total comfort.

Input

First line contains single integer n (1 ≤ n ≤ 5000) — number of people.

Second line contains n space-separated integers a1, a2, ..., an (0 ≤ ai ≤ 5000), where ai denotes code of the city to which i-th person is going.

Output

The output should contain a single integer — maximal possible total comfort.

Examples
input
6
4 4 2 5 2 3
output
14
input
9
5 1 3 1 5 2 4 2 5
output
9
Note

In the first test case best partition into segments is: [4, 4] [2, 5, 2] [3], answer is calculated as follows: 4 + (2 xor5) + 3 = 4 + 7 + 3 = 14

In the second test case best partition into segments is: [3] [2, 4, 2] 5, answer calculated as follows: 3 + (2 xor 4) = 3 + 6 = 9.

#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
#define mem(s,v) memset(s,v,sizeof(s))
#define inf 0x3f3f3f3f
int a[5010],fi[5010],se[5010],dp[5010],vis[5010];
int main(){
    int n;
    scanf("%d",&n);
    mem(a,0);
    for(int i=1;i<=n;i++){
        scanf("%d",&a[i]);
        if(!fi[a[i]]) fi[a[i]]=i;
        se[a[i]]=i;
    }
    for(int i=1;i<=n;i++){
        dp[i]=dp[i-1];
        mem(vis,0);
        int st=i,res=0;
        for(int j=i;j;j--){
            if(!vis[a[j]]){
                if(se[a[j]]>i) break;
                if(fi[a[j]]<st) st=fi[a[j]];
                res^=a[j];vis[a[j]]=1;
            }
            if(j<=st) dp[i]=max(dp[i],dp[j-1]+res);
        }
    }
    printf("%d\n",dp[n]);
    return 0;
}